/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkSatisfy(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.postDrunk;
    var subController = ctrl.preDeath;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidDrunkSatisfyDad(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            After that day, the relationship between Falco and you takes a turn for the better.
                            Your intense bouts of lovemaking become more [b]passionate[/b], more [b]gentle[/b].
                            He kisses you on the lips, eats you out, prepares you with his fingers and even cuddles with you afterwards,
                            instead of just pumping his dick in and out of you until he cums, then leaving you to clean up the mess.
                        [/p]
                        [p]
                            Perhaps that [i]spark[/i] you saw in his eyes was one of [i]love[/i].
                            Or maybe he's finally coming to terms with becoming a [i]father[/i].
                            Either way, you're not complaining.
                            A bit of [b]tenderness[/b] is exactly what your hormonal body needed.
                            It's like he's starting to treat you like a lover instead of a [i]whore[/i].
                            And while you aren't ready to admit it yet, you are growing feelings for the eagle as well.
                        [/p]
                        [p]
                            As weeks go by, your belly bulges further and further.
                            The baby must be getting bigger.
                            Romeo and Juliet take notice.
                            Luckily, they're naive enough to believe the lie that you must have gotten pregnant [i]before[/i] becoming their slave,
                            and that it's a [b]slow-growing[/b] child gestating inside of you.
                            Or maybe they don't [i]want[/i] to face the fact that their son is one who lays with kobolds.
                        [/p]
                        [p]
                            Falco talks his parents into letting you stay in bed with him, at night.
                            Sure beats sleeping in the dog basket.
                            The bird and yourself often fool around before going to sleep,
                            although the rare few times that you're [b]not[/b] in the mood to fuck,
                            your feathery friend understands completely.
                            He no longer forces himself upon you.
                            He's grown to respect your boundaries,
                            and you, in turn, show him a bit more affection as well.
                        [/p]
                        [p]
                            The two of you grow closer and closer together, until one day,
                            a broadly built horse walks through the front door, carrying a dire missive.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
