/**
 * Ruby section of Varanar, Afternoon Three.
 * @param {AfternoonThreeRubyController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeRubyPantiesCombine(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = AfternoonThreeRubyPantiesChoice.COMBINE;
    var reqController = ctrl.panties;
    var subController = false;
    var changeController = ctrl.pantiesCombine;

    var autoContinue = true;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.postPanties;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var t1 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt1;
        var t2 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt2;
        var t3 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt3;
        var underwear = ctrl.misc.underwear();
        var underwearPopup = global.kobold.inventory.createItemWithTooltip(underwear);
        var pants = ctrl.misc.pants();
        var pantsPopup = global.kobold.inventory.createItemWithTooltip(pants);
        var toReturn = `[p]
                            Alright!
                            A second pair of panties!
                            And still warm, too, fresh from the dragoness' loins.
                            These'll go great with your current underwear!
                            They even look kind of similar.
                        [/p]
                        [p]
                            ${pants ? `You take off your ${pantsPopup}, revealing your ${underwearPopup}.` : ``}
                            The lady watches on in confusion, as you deftly slip her snug and comfortable undies over your current pair.
                            They're a bit big, but not by [i]too[/i] much.
                            The [i]lower layer[/i] fills them out nicely.
                            You reckon they were a little too small for the lady.
                        [/p]
                        [p]
                            "[color=cyan]${t1 ? `You [b]filthy[/b] underwear-layering [b]freak[/b]!
                            I hope you [b]die[/b] wearing those!` : t2 ? `I knew you were some kind of [b]deviant[/b],
                            putting on two pairs of underwear.` : `The more panties, the better, I suppose.
                            They look [i]kind of[/i] cute on you.`}[/color]"
                            ${t1 ? `You ignore the woman's rambling.` : ``}
                            ${t2 ? `You ignore the woman's insult.` : ``}
                            ${pants ? `You tug your ${pantsPopup} up once more. Can't give her too much of a show, right?` : ``}
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
