/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkDeclineBite(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkDeclineDadChoice.BITE;
    var reqController = ctrl.death;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var broom = ctrl.drunk.get() === FarmerMaidDrunkChoice.DECLINE;
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            You consider running, but the moment the thought crosses your mind,
                            the bird whistles for his dog, who comes running out of the house to stand by his side.
                            It growls loudly at you, menacingly baring its teeth.
                            Fearing for your very life, you reluctantly walk back home with the sadistic avian,
                            back into a life of slavery and servitude.
                        [/p]
                        [p]
                            The daily grind continues.
                            Falco works the fields, providing food for Juliet and yourself.
                            You keep the house clean, your duties interrupted by frequent feral fucking.
                            You notice the human woman starting to spy on you whenever the canine ruts you.
                            Ever since her husband died, she no longer has a way to [i]sate[/i] her needs.
                            And you think that growing desire is slowly starting to drive her insane.
                        [/p]
                        [p]
                            Whenever you get close to the door, the dog begins to growl and bark.
                            The eagle probably trained it to [b]attack[/b] you, should you try to leave.
                            You keep trying to look for ways to [b]escape[/b], but even if you [i]could[/i] make it out the door,
                            there's little chance of you evading every single inhabitant of the entire hamlet.
                            And after you escape, where would you go?
                            ${broom ? `Nowhere.` : `A pregnant kobold on the run would be an easy target for just about anyone.`}
                        [/p]
                        [p]
                            The mother of the house begins to quite openly masturbate to your unwilling sessions with her son's pet.
                            One day, when the dog tackles you while cleaning the lady's room, she walks up in front of you,
                            drops her pants, and wordlessly sets her loins down atop your muzzle, grinding her needy cunt into your scales.
                            You can refuse her service, but what's the point?
                            It'll only make things worse for you.
                            Your tongue snakes out of your mouth, and while the canine wildly humps away,
                            you dutifully eat out your new [i]mistress[/i], hoping she'll at least let you stay in bed with her after this.
                            No such luck.
                        [/p]
                        ${broom ? `
                        [p]
                            The awkward threesomes continue for the better half of a week.
                            Then, Juliet figures out how to get the dog to fuck [b]her[/b] instead.
                            She gets pounded to orgasm after orgasm underneath a dog the same weight as her.
                            She [b]loves[/b] it.
                            It's like happiness returns to her life,
                            all the bitterness and coldness washing away amidst a torrent of watery canine spunk.
                        [/p]
                        [p]
                            Instead of you being allowed to sleep in her bed,
                            it is the dog that gets a place by Juliet's side at night.
                            You don't mind.
                            At least you get the basket back.
                            Much better than sleeping on the floor.
                            With the canine fucking the human all day long, it is no longer interested in you.
                            You live out the rest of your life in relative peace, as a servant.
                            You tidy the house, you clean up after your new [i]mistress[/i]' feral escapades,
                            and you fight over scraps with the dog that has usurped your rightful place in this house.
                        [/p]` : `
                        [p]
                            A month later, you go into labour.
                            In the middle of the kitchen, you give birth to a baby kobold boy.
                            But he's not moving.
                            He's not breathing.
                            Your child is stillborn.
                            Weeping openly, you press the carcass against your chest.
                            Your mind snaps.
                            Sadness turns to apathy.
                            You feel nothing from that day onwards.
                            No joy.
                            No sadness.
                            No love.
                            No hate.
                            Your mind is blank.
                            Your body functions autonomously.
                            You serve until you die of old age.
                            Nobody mourns for you.
                        [/p]`}
                        [p]
                            [c]
                                [b]
                                    Two bitches and a dog end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [nl]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}
